
phi = 90.0*Math.PI*2/360
rotatiematrix = [Math.cos(phi),Math.sin(phi),-Math.sin(phi),Math.cos(phi)];
schaal = 10;   //slechte experimentele waarde
canvasdim = [500,500];
afstand = 0;
var isDrawable=false;
var x_start = [canvasdim[0]/2.0,canvasdim[1]/2.0];
var schalingsmethode=0;
var raster=false;
var lengterechtstuk=1;


function Herinitialiseer (){
    if(isDrawable){
    beginpunt.remove();
//    eindpunt.remove();
    logo.remove();
    rooster.remove();
    canvasdim = determineSize();
    h = getPosition(document.getElementById('canvas_container'));
    canvasdim[0] = .96*canvasdim[0];  //experimentele waarde
    canvasdim[1] = canvasdim[1]-1.4*h;  //experimentele waarde
    paper.setSize(canvasdim[0],canvasdim[1]);
    BepaalAfstand();
    if (raster){
        f=Math.ceil((canvasdim[0]/lengterechtstuk)/30);
//        console.log(f);
        pad = "";
        for(x=x_start[0]; x<canvasdim[0]; x=x+f*lengterechtstuk){
            pad = pad + "M" + x + " 0" + "L" + x + " " + canvasdim[1];
        }
        for(x=x_start[0]-f*lengterechtstuk; x>0; x=x-f*lengterechtstuk){
            pad = pad + "M" + x + " 0" + "L" + x + " " + canvasdim[1];
        }
        for(x=x_start[1]; x<canvasdim[1]; x=x+f*lengterechtstuk){
            pad = pad + "M" + "0 " + x + "L" + canvasdim[0] + " " + x;
        }
        for(x=x_start[1]-f*lengterechtstuk; x>0; x=x-f*lengterechtstuk){
            pad = pad + "M" + "0 " + x + "L" + canvasdim[0] + " " + x;
        }
        rooster = paper.path(pad);
        rooster.attr({'stroke-dasharray': ".", stroke: '#ddd'});
        } else
        { rooster = paper.path("");}
    logo = paper.text(canvasdim[0], canvasdim[1]-10, 'Wiskunde B-dag 2012')
    logo.attr({opacity: .5, 'font-size': 8, 'text-anchor': 'end'}).toBack();
//    if(afstand==0){afstand=.4*canvasdim[0];}
//    afstand=BepaalAfstand(schalingsmethode);
    beginpunt = paper.circle(x_start[0],x_start[1],.005*canvasdim[0]);
//    eindpunt = paper.circle(x_start[0]+1*afstand,x_start[1],.005*canvasdim[0]);
      // die '1' is om onduidelijke redenen noodzakelijk...
    beginpunt.attr({fill: '#888', stroke: '#ddd', 'stroke-width': 0});
//    eindpunt.attr({fill: '#888', stroke: '#ddd', 'stroke-width': 0});
    TekenPatroon();
    }
    return 0;
}

function BepaalAfstand(){
    invoer = document.getElementById('vouwinstructie').value;
    switch(schalingsmethode){
        case 1: if(canvasdim[0]<canvasdim[1]){
                afstand = .5*canvasdim[0];
            } else{
                afstand = .5*canvasdim[1];
            }
            x_start = [(canvasdim[0]-afstand)/2.0,canvasdim[1]/2.0];
            break;
        case 2:            
            afstand=lengterechtstuk*Math.pow(2+2*Math.cos(phi),.5*invoer.length);
            x_start = [canvasdim[0]/2.0,canvasdim[1]/2.0];
            break;
        case 0:
            vp = VouwinstructieNaarVouwpatroon(invoer);
            richting = [1,0];
            positie = [1,0];
            xmax = [1,0];
            xmin = [0,0];
            for (a=0; a<vp.length; a++){
                richting = NieuweRichting(rotatiematrix,richting,vp[a]);
                positie = [positie[0]+richting[0],positie[1]+richting[1]];
                if(positie[0]>xmax[0]){xmax[0]=positie[0];}
                if(positie[1]>xmax[1]){xmax[1]=positie[1];}
                if(positie[0]<xmin[0]){xmin[0]=positie[0];}
                if(positie[1]<xmin[1]){xmin[1]=positie[1];}
            }
            xmax=[xmax[0]+1,xmax[1]+1];
            xmin=[xmin[0]-1,xmin[1]-1];
            afstand=Math.pow(2+2*Math.cos(phi),.5*invoer.length)*.95*Math.min(canvasdim[0]/Math.max(1,(xmax[0]-xmin[0])),canvasdim[1]/Math.max(1,(xmax[1]-xmin[1])));
            x_start=[canvasdim[0]*Math.abs(xmin[0]/Math.max(1,(xmax[0]-xmin[0]))),canvasdim[1]*Math.abs(xmin[1]/Math.max(1,(xmax[1]-xmin[1])))];
//            x_start=[x_start[0]+.005*canvasdim[0],x_start[1]-0.005*canvasdim[1]];
//            document.getElementById('debg').value = "1";
            break;
        default: if(afstand==0){afstand=.4*canvasdim[0];}
//                 x_start = [(canvasdim[0]-afstand)/2.0,canvasdim[1]/2.0];
    }
}

function VerwerkHoek (h){
    hoek = document.getElementById('hoek').value;
    phi = hoek*Math.PI*2/360
    rotatiematrix = [Math.cos(phi),Math.sin(phi),-Math.sin(phi),Math.cos(phi)];
    VerwerkVouwinstructie(0);
    return 0;
}
//
//function ResetHoek(){
//    document.getElementById('hoek').value=90;
//    VerwerkHoek(0);
//    fdSlidercontroller.updateSlider("slider-v1");
//    return 0;
//}

//function VerwerkAfstand (s){
//    if(isDrawable){
//        afstand = canvasdim[0]*document.getElementById('afstand').value/100;
//        Herinitialiseer();
//    }
//    return 0;
//}

//function VerwerkLengteRechtStuk (s){
//    if(isDrawable){
//        lengterechtstuk = canvasdim[0]*document.getElementById('lengterechtstuk').value/100;
//        Herinitialiseer();
//    }
//    return 0;
//}

function VerwerkSchaling (){
    if(isDrawable){
        if(document.getElementById('button1').checked) {schalingsmethode=0;
            raster=false;}
//        if(document.getElementById('button2').checked) {schalingsmethode=1;
//            raster=false;}
        if(document.getElementById('button3').checked) {schalingsmethode=2;
            lengterechtstuk = canvasdim[0]*document.getElementById('lengterechtstuk').value/10000;
//            raster=document.getElementById('raster').checked;
        }
        Herinitialiseer();
    }
    return 0;
}


function VerwerkVouwinstructie (vi){
    if(schalingsmethode!=1){Herinitialiseer();}
    else{TekenPatroon();}
}

function TekenPatroon (){
    invoer = document.getElementById('vouwinstructie').value;
    if (invoer==""){
        if (isDrawable){
            snakecurve.remove();
            pad = "M "+ x_start[0] + " " + x_start[1] + " l " + afstand + " 0";
            snakecurve = paper.path(pad);
        }
    }
    else
    {
        vp = VouwinstructieNaarVouwpatroon(invoer);
        var vpstring = new String();
        for (a=0; a<vp.length; a++){
            vpstring=vpstring+((vp[a]==1)?"L":"R");
        }
        document.getElementById('patrooncode').value = vpstring;
        if (isDrawable){
            
            snakecurve.remove();

            //bepaal de schaal
            schaal = afstand/(Math.pow(2+2*Math.cos(phi),.5*invoer.length));
            pad = "M "+ x_start[0] +" "+ x_start[1];
            
            //initialiseer startrichting:
            richting = [1,0];
            if(schalingsmethode==1){
                for (a=0; a<invoer.length; a++){
                    //draairichting bepalen
                    switch (invoer.charAt(a)){
                            case '+': theta=-.5*phi; break;
                            case '-': theta=.5*phi; break;
                            default: theta=0;   // nog geen foutenafhandeling...
                    }
                    //draaien om 1/2*(pi-phi)...
                    richting=[richting[0]*Math.cos(theta)-richting[1]*Math.sin(theta),richting[1]*Math.cos(theta)+richting[0]*Math.sin(theta)];
                }
            }
            
            pad = pad + " l " + schaal*richting[0] + " " + schaal*richting[1];
            for (a=0; a<vp.length; a++){
                richting = NieuweRichting(rotatiematrix,richting,vp[a]);
                pad = pad + " l " + schaal*richting[0] + " " + schaal*richting[1];

            }
//            switch (vp[(vp.length-1)/2]){    //middelste teken
//              case +1: richting=[Math.cos(phi/2),-Math.sin(phi/2)]; break;
//              case -1: richting=[Math.cos(phi/2),Math.sin(phi/2)]; break;
//              }
//            pad = pad + " l " + schaal*richting[0] + " " + schaal * richting [1];
//            
                            
//            for (a=(vp.length+1)/2; a<vp.length; a++){
//                richting = NieuweRichting(rotatiematrix,richting,vp[a]);
//                pad = pad + " l " + schaal*richting[0] + " " + schaal * richting [1];
//              }

//            pad = pad + " M "+ x_start[0] +" "+ x_start[1];
//            switch (vp[(vp.length-1)/2]){    //middelste teken
//              case +1: richting=[-Math.cos(phi/2),-Math.sin(phi/2)]; break;
//              case -1: richting=[-Math.cos(phi/2),Math.sin(phi/2)]; break;
//              }
//              pad = pad + " l " + schaal*richting[0] + " " + schaal * richting [1];
//            for (a=(vp.length-3)/2; a>-1; a--){
//                richting = NieuweRichting(rotatiematrix,richting,-vp[a]);
//                pad = pad + " l " + schaal*richting[0] + " " + schaal * richting [1];
//              }
            
            snakecurve = paper.path(pad); 
        }
    }
    return 0;
}

function BepaalNieuweCoordinaat(oud,ri){
    return [oud[0]+schaal*ri[0],oud[1]+schaal*ri[1]];
}


function NieuweRichting (rx,ri,vouw){
    return [rx[0]*ri[0]+vouw*rx[1]*ri[1],vouw*rx[2]*ri[0]+rx[3]*ri[1]];
}

function VouwinstructieNaarVouwpatroon (v){
   // uitvoer is een array
    n=v.length;
    var w = new Array();
    /*  Notatie 1<<n is bitshift, dus equivalent met 2^n (maar die latere notatie bestaat niet in C)
     De strings v en w zijn arrays van char's, die beginnen met index 0; vandaar de '-1'  */
    w[(1<<(n-1))-1]=PlusMinNaarInt(v.charAt(0));      // Dit is de middelste vouw; deze heeft geen antisymmetrische tegenpool
    for (a=0; a<n-1; a++){
        for (k=0; k<(1<<(n-2-a)); k++){
            w[(1<<a)*(1+4*k)-1]=PlusMinNaarInt(v.charAt(n-a-1));
            w[(1<<a)*(3+4*k)-1]=-PlusMinNaarInt(v.charAt(n-a-1));
            }
        }

    return w;
}

function PlusMinNaarInt (pm){
    switch (pm){
        case 'r': i=-1; break;
        case 'l': i=1; break;
        default: i=1;   // geen foutenafhandeling...
    }
    return i;
}


window.onresize = function() {
    Herinitialiseer();
}

// van http://www.howtocreate.co.uk/tutorials/javascript/browserwindow :
function determineSize() {
  var myWidth = 0, myHeight = 0;
  if( typeof( window.innerWidth ) == 'number' ) {
    //Non-IE
    myWidth = window.innerWidth;
    myHeight = window.innerHeight;
  } else if( document.documentElement && ( document.documentElement.clientWidth || document.documentElement.clientHeight ) ) {
    //IE 6+ in 'standards compliant mode'
    myWidth = document.documentElement.clientWidth;
    myHeight = document.documentElement.clientHeight;
  } else if( document.body && ( document.body.clientWidth || document.body.clientHeight ) ) {
    //IE 4 compatible
    myWidth = document.body.clientWidth;
    myHeight = document.body.clientHeight;
  }
  return [myWidth,myHeight];
}

// van: http://www.hiteshagrawal.com/javascript/calculating-div-position-in-javascript :
// usage: getPosition(document.getElementById('divname'));
function getPosition(obj){
    var topValue= 0;
    while(obj){
	topValue+= obj.offsetTop;
	obj= obj.offsetParent;
    }
    return topValue;
}

